/*

The Life of a Geek
Copyright (C) 2003-2004 Daniel Quintiliani

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can e-mail Daniel Quintiliani at coredump0@mercurylink.net

commands.cc: The commands the menus call.

2/3/04: Daniel Quintiliani <coredump0@mercurylink.net>: Updated e-mail address
and copyright. 
7/4/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated code for new
readfromfilevars(), added hacker battling, removed unnecessary code in
CmdWasteTime(), CmdWork(), CmdSpeedClass(), and CmdHack(), updated
CmdAntiVirus(), updated CmdWasteTime() with new options.
6/14/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed support for
older compilers/C libraries.
6/13/03: Daniel Quintiliani <coredump@coredumpcentral.org>: CmdWasteTime()
updated, added elapsed time code, CmdWork() updated, randomness improved in 
CmdWasteTime() and CmdWork(), CmdSpeedClass() updated.
5/21/03: Daniel Quintiliani <coredump@coredumpcentral.org>: CmdWasteTime() 
updated.
5/20/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Text file transition
(almost) complete.
4/24/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed a bug where
only one energy drink would be bought instead of what user specified.
4/7/03: Daniel Quintiliani <coredump@coredumpcentral.org>: To be more
considerate, replaced all bools with ints.

*/

#include "func.h"
#include <iostream>

using namespace std;

void CmdWasteTime(Geek &geek, Computer &comp, ElTime &elt)
{
	srand((unsigned)time(NULL));
	float f = 1.0 + ((float)18.0 * rand() / RAND_MAX);
	int n = (int)roundf(f);
	if(n == 19) n = 18;
	
	switch(n)
	{
		case 1:
		{
			cout << readfromfile(WASTEFILE,"!WASTE1",0);
			break;
		}
		case 2:
		{
			cout << readfromfile(WASTEFILE,"!WASTE2",0);
			break;
		}
		case 3:
		{
			cout << readfromfile(WASTEFILE,"!WASTE3",0);
			break;
		}
		case 4:
		{
			cout << readfromfile(WASTEFILE,"!WASTE4",0);
			break;
		}
		case 5:
		{
			cout << readfromfile(WASTEFILE,"!WASTE5",0);
			break;
		}
		case 6:
		{
			cout << readfromfile(WASTEFILE,"!WASTE6",0);
			break;
		}
		case 7:
		{
			cout << readfromfile(WASTEFILE,"!WASTE7",0);
			break;
		}
		case 8:
		{
			cout << readfromfile(WASTEFILE,"!WASTE8",0);
			break;
		}
		case 9:
		{
			cout << readfromfile(WASTEFILE,"!WASTE9",0);
			break;
		}
		case 10:
		{
			cout << readfromfile(WASTEFILE,"!WASTE10",0);
			break;
		}
		case 11:
		{
			cout << readfromfile(WASTEFILE,"!WASTE11",0);
			break;
		}
		case 12:
		{
			cout << readfromfile(WASTEFILE,"!WASTE12",0);
			break;
		}
		case 13:
		{
			cout << readfromfile(WASTEFILE,"!WASTE13",0);
			break;
		}
		case 14:
		{
			cout << readfromfile(WASTEFILE,"!WASTE14",0);
			break;
		}
		case 15:
		{
			cout << readfromfile(WASTEFILE,"!WASTE15",0);
			break;
		}
		case 16:
		{
			cout << readfromfile(WASTEFILE,"!WASTE16",0);
			break;
		}
		case 17:
		{
			cout << readfromfile(WASTEFILE,"!WASTE17",0);
			break;
		}
		case 18:
		{
			cout << readfromfile(WASTEFILE,"!WASTE18",0);
			break;
		}
		
		if(n==8||n==18)
		{
			float sec = (float)100.0 * rand() / RAND_MAX;
                        if( sec < 20.0 && comp.GetSecurity() < (comp.GetMaxHealth() / 4) )
                        {
                                cout << readfromfile(WASTEFILE,"!WASTESEC",0);
                                comp.SetSecurity(comp.GetSecurity() + 1);
                        }
		}

	}
	
	geek.SetEnergy(geek.GetEnergy() - 10);
	elt.AddHour(4);

}

void CmdSpeedClass(Geek &geek, Computer &comp, ElTime &elt)
{
	srand((unsigned)time(NULL));
	float f = (float)100.0 * rand() / RAND_MAX;
	int n = (int)roundf(f);
	
	if(n < geek.GetEducation())
		cout << readfromfile(MAINFILE,"!NOCLASS",0);
	else
	{
		geek.SetMoney(geek.GetMoney() - 1500);
		FuncGenAttack(comp, 20);
		elt.AddMonth(1);
		f = (float)100.0 * rand() / RAND_MAX;
		if(f<25.0)
			cout << readfromfile(MAINFILE,"!CLASSF",0);
		else
		{
			cout << readfromfile(MAINFILE,"!CLASSP",0);
			geek.SetEducation(geek.GetEducation() + 1);	
		}
	}
}

void CmdWork(Geek &geek, Computer &comp, ElTime &elt)
{
	srand((unsigned)time(NULL));
	float f = (float)100.0 * rand() / RAND_MAX;

	if(f < 30.0)
		cout << readfromfile(JOBFILE,"!NOJOB",0);
	else
	{
		f = 1.0 + ((float)6.0 * rand() / RAND_MAX);
		int n = (int)roundf(f);
		if(n == 7) n = 6;
	
		cout << readfromfile(JOBFILE,"!JMAIN",1);
	
		switch(n)
		{
			case 1:
				cout << readfromfile(JOBFILE,"!JOB1",0);
				break;
			case 2:
				cout << readfromfile(JOBFILE,"!JOB2",0);
				break;
			case 3:
				cout << readfromfile(JOBFILE,"!JOB3",0);
				break;
			case 4:
				cout << readfromfile(JOBFILE,"!JOB4",0);
				break;
			case 5:
				cout << readfromfile(JOBFILE,"!JOB5",0);
				break;
			case 6:
				cout << readfromfile(JOBFILE,"!JOB6",0);
				break;
		}
	
	        float Profit = 100.0 + (float)(400.0 * rand()) / (RAND_MAX + 1.0);
		Profit = floattocurrency(Profit);
		if(Profit>400.0) Profit -= 100.0;
		geek.SetMoney(geek.GetMoney() + Profit);
		cout << readfromfilevars(JOBFILE,"!JOBEARN",0,geek,comp,comp,elt,0,Profit,"","","");	
	
		FuncGenAttack(comp, 40);
		elt.AddMonth(1);
	}
}

void CmdBuyEnergyDrink(Geek &geek, ElTime &elt, int n)
{
	geek.SetMoney(geek.GetMoney() - (10 * n));
	geek.SetEnergyDrinks(geek.GetEnergyDrinks() + n);
	elt.AddMin(10);
}

void CmdDrinkEnergyDrink(Geek &geek, ElTime &elt)
{
	geek.SetEnergyDrinks(geek.GetEnergyDrinks() - 1);
	geek.SetEnergy(geek.GetEnergy() + 25);
	elt.AddMin(5);
}

int CmdHack(Geek &geek, Computer &comp, ElTime &elt)
{
	geek.SetEnergy(geek.GetEnergy() - 50);
	elt.AddHour(6);
	srand((unsigned)time(NULL));
	float f = (float)100.0 * rand() / (RAND_MAX + 1.0);
	if(f<60.0)
	{
		string s;
		int Turns = 0;
		cout << readfromfile(MAINFILE,"!HAKRFOUND",0);
		f = (float)(comp.GetMaxHealth() / 4) * rand() / RAND_MAX;
		int EnemyMaxHP = comp.GetMaxHealth() + (int)roundf(f);
		f = (float)(EnemyMaxHP / 4) * rand() / RAND_MAX;
		int EnemySec = (int)roundf(f);
		Computer ecomp;
		ecomp.SetHealth(EnemyMaxHP);
		ecomp.SetMaxHealth(EnemyMaxHP);
		ecomp.SetSecurity(EnemySec);
		ecomp.SetLevel(comp.GetLevel());
		while(ecomp.GetHealth() > 0)
		{
			cout << readfromfilevars(MAINFILE,"!HAKRMAIN",0,geek,
			comp,ecomp,elt,0,0,"","","");
			cout << readfromfile(MAINFILE,"!PENTER",1);
			getline(cin,s);
			gpl_check_and_strlwr(s);
			if(s[0]=='a')
				AttackEnemy(ecomp);
			else if(s[0]=='u')
				UploadVirus(ecomp);
			else if(s[0]=='n')
				HackAntiVir(geek,comp);
			else if(s[0]=='l')
				if(LogOff()==0) return 0;
			FuncGenAttack(comp,55);
			DeductVirAndHeal(ecomp,elt,1);
			if(DeductVirAndHeal(comp,elt,0)==-1)
				return -1;
			Turns++;
		}
		Victory(geek, comp, elt, Turns);
	}
	else
		cout << readfromfile(MAINFILE,"!NOHAKRFOUND",0);
	return 0;
}

void CmdAntiVirus(Geek &geek, Computer &comp, ElTime &elt, float Cost)
{
	geek.SetMoney(geek.GetMoney() - Cost);
	comp.SetInfected(1);
	if(Cost<30.0)
	{	comp.SetHealth(comp.GetMaxHealth());
		elt.AddMin(30);}
}

void CmdSleep(Geek &geek, Computer &comp, ElTime &elt)
{
	geek.SetEnergy(geek.GetEnergy() + 50);
	FuncGenAttack(comp, 60);
	elt.AddHour(16);
}
